# Rollbot v4

- document store
    - index on chat, channel, etc.
    - defined by class
    - back by sqlite
- proper API for representing a source and response logic
- liberal use of dependency injection
- use asyncio/allow commands to be async

Things that can be accessed in a command, regardless of platform:
    - Message
        - Source
        - Channel
        - Sender
        - Message Text
            - Parsed and converted arguments
        - Timestamp
        - Admin? (group vs global)
        - Attachments?
    - Configuration
        - Secrets
    - Database
        - Query by source, channel, user, etc.
        - Inject more specific queries
    - Response
        - Abstracted way to respond manually
        - Should support attachment of some kind? Maybe just images?
